package observer;

import java.util.Observable;
import java.util.Observer;

public class OpenNotifier extends Observable {
	private Flower _enclosing;
	private boolean alreadyOpen = false;
	public OpenNotifier(Flower flower) {
		_enclosing = flower;
	}
	public void notifyObservers() {
		if(_enclosing.isOpen() && !this.alreadyOpen) {
			this.setChanged();
			super.notifyObservers();
			this.alreadyOpen = true;
		}
	}
	public void close() {
		this.alreadyOpen = false;
	}
}
