package observer;

import java.util.Observable;
import java.util.Observer;

public aspect ObservingClose {
	declare parents: (Bee || Hummingbird) implements BedtimeSleeper;

	private CloseNotifier Flower.cNotify = new CloseNotifier(this);
	private CloseObserver Bee.closeObsrv = new CloseObserver(this);
	private CloseObserver Hummingbird.closeObsrv = new CloseObserver(this);

	public Observable Flower.closing() {
		return cNotify;
	}
	pointcut flowerOpen(Flower flower):
		execution(void open()) && this(flower);
	after(Flower flower) returning : flowerOpen(flower) {
		flower.cNotify.open();
	}
	pointcut flowerClose(Flower flower):
		execution(void close()) && this(flower);
	after(Flower flower): flowerClose(flower) {
		flower.cNotify.notifyObservers();		
	}

	public Observer Bee.closeObserver() { 
		return closeObsrv;
	}
	public Observer Hummingbird.closeObserver() { 
		return closeObsrv;
	}
}
