package observer;

import java.util.Observable;
import java.util.Observer;

public aspect ObservingOpen {
	declare parents: (Bee || Hummingbird) implements BreakfastTaker;

	private	OpenNotifier Flower.oNotify = new OpenNotifier(this);
	private OpenObserver Hummingbird.openObsrv = new OpenObserver(this);
	private OpenObserver Bee.openObsrv = new OpenObserver(this);
	public Observable Flower.opening() {
		return oNotify;
	}
	pointcut flowerOpen(Flower flower):
		execution(void open()) && this(flower);
	after(Flower flower) returning : flowerOpen(flower) {
		flower.oNotify.notifyObservers();
	}
	pointcut flowerClose(Flower flower):
		execution(void close()) && this(flower);
	after(Flower flower): flowerClose(flower) {
		flower.oNotify.close();
	}
	public Observer Bee.openObserver() { 
		return openObsrv; 
	}
	public Observer Hummingbird.openObserver() { 
		return openObsrv;
	}
}
