package observer;

import java.util.Observable;
import java.util.Observer;

public aspect ObservingClose {
	private interface BedtimeSleeper {
		public void bedtimeSleep();
	}
	declare parents: (Bee || Hummingbird) implements BedtimeSleeper;

	static class CloseNotifier extends Observable {
		private Flower _enclosing;
		private boolean alreadyClosed = false;
		public CloseNotifier(Flower flower) {
			_enclosing = flower;
		}
		public void notifyObservers() {
			if(!_enclosing.isOpen() && !this.alreadyClosed) {
				this.setChanged();
				super.notifyObservers();
				this.alreadyClosed = true;
			}
		}
		public void open() {
			this.alreadyClosed = false;
		}
	}
	static class CloseObserver implements Observer {
		private BedtimeSleeper _enclosing;
		public CloseObserver(BedtimeSleeper enclosing) {
			_enclosing = enclosing;
		}
		public void update(Observable ob, Object a) {
			_enclosing.bedtimeSleep();
		}
	}
	private CloseNotifier Flower.cNotify = new CloseNotifier(this);
	private CloseObserver Bee.closeObsrv = new CloseObserver(this);
	private CloseObserver Hummingbird.closeObsrv = new CloseObserver(this);

	public Observable Flower.closing() {
		return cNotify;
	}
	pointcut flowerOpen(Flower flower):
		execution(void open()) && this(flower);
	after(Flower flower) returning : flowerOpen(flower) {
		flower.cNotify.open();
	}
	pointcut flowerClose(Flower flower):
		execution(void close()) && this(flower);
	after(Flower flower): flowerClose(flower) {
		flower.cNotify.notifyObservers();		
	}

	public Observer Bee.closeObserver() { 
		return closeObsrv;
	}
	public Observer Hummingbird.closeObserver() { 
		return closeObsrv;
	}
}
