package observer;

public aspect ObservingOpen {
	private interface Subject {}
	private interface Observer {}
	declare parents: Flower implements Subject;
	declare parents: (Bee || Hummingbird) implements Observer;

	public abstract boolean Subject.isOpen();
	public abstract void Observer.breakfastTime();

//	private interface BreakfastTaker {
//		public void breakfastTime();
//	}
//	declare parents: (Bee || Hummingbird) implements BreakfastTaker;

	static class OpenNotifier extends java.util.Observable {
		private Subject _enclosing;
		private boolean alreadyOpen = false;
		public OpenNotifier(Subject flower) {
			_enclosing = flower;
		}
		public void notifyObservers() {
			if(_enclosing.isOpen() && !this.alreadyOpen) {
				this.setChanged();
				super.notifyObservers();
				this.alreadyOpen = true;
			}
		}
		public void close() {
			this.alreadyOpen = false;
		}
	}
	static class OpenObserver implements java.util.Observer {
		private Observer /*BreakfastTaker*/ _enclosing;
		public OpenObserver(Observer /*BreakfastTaker*/ enclosing) {
			_enclosing = enclosing;
		}
		public void update(java.util.Observable ob, Object a) {
			_enclosing.breakfastTime();
		}
	}
	private	OpenNotifier Subject.oNotify = new OpenNotifier(this);
	private OpenObserver /*Hummingbird*/Observer.openObsrv = new OpenObserver(this);
//	private OpenObserver Bee.openObsrv = new OpenObserver(this);

	public java.util.Observable Subject.opening() {
		return oNotify;
	}
	pointcut flowerOpen(Subject subject):
		execution(void open()) && this(subject);
	after(Subject subject) returning : flowerOpen(subject) {
		subject.oNotify.notifyObservers();
	}
	pointcut flowerClose(Subject subject):
		execution(void close()) && this(subject);
	after(Subject subject): flowerClose(subject) {
		subject.oNotify.close();
	}

	public java.util.Observer /*Hummingbird*/Observer.openObserver() { 
		return openObsrv;
	}
//	public java.util.Observer Bee.openObserver() { 
//		return openObsrv; 
//	}
}