package observer;

//import java.util.Observable;
//import java.util.Observer;

public aspect ObservingClose {
	private interface Subject {}
	private interface Observer {}

	declare parents: Flower implements Subject;
	declare parents: (Bee || Hummingbird) implements Observer;

	public abstract boolean Subject.isOpen();
	public abstract void Observer.bedtimeSleep();

//	private interface BedtimeSleeper {
//		public void bedtimeSleep();
//	}
//	declare parents: (Bee || Hummingbird) implements BedtimeSleeper;

	static class CloseNotifier extends java.util.Observable {
		private Subject _enclosing;
		private boolean alreadyClosed = false;
		public CloseNotifier(Subject flower) {
			_enclosing = flower;
		}
		public void notifyObservers() {
			if(!_enclosing.isOpen() && !this.alreadyClosed) {
				this.setChanged();
				super.notifyObservers();
				this.alreadyClosed = true;
			}
		}
		public void open() {
			this.alreadyClosed = false;
		}
	}
	static class CloseObserver implements java.util.Observer {
		private Observer /*BedtimeSleeper*/ _enclosing;
		public CloseObserver(Observer /*BedtimeSleeper*/ enclosing) {
			_enclosing = enclosing;
		}
		public void update(java.util.Observable ob, Object a) {
			_enclosing.bedtimeSleep();
		}
	}
	private CloseNotifier Subject.cNotify = new CloseNotifier(this);
//	private CloseObserver Bee.closeObsrv = new CloseObserver(this);
	private CloseObserver /*Hummingbird*/ Observer.closeObsrv = new CloseObserver(this);

	public java.util.Observable Subject.closing() {
		return cNotify;
	}
	pointcut flowerOpen(Subject /*flower*/ subject):
		execution(void open()) && this(/*flower*/ subject);
	after(Subject /*flower*/ subject) returning : flowerOpen(/*flower*/ subject) {
		subject.cNotify.open();
	}
	pointcut flowerClose(Subject /*flower*/ subject):
		execution(void close()) && this(/*flower*/ subject);
	after(Subject /*flower*/ subject): flowerClose(/*flower*/ subject) {
		subject.cNotify.notifyObservers();		
	}

//	public java.util.Observer Bee.closeObserver() { 
//		return closeObsrv;
//	}
	public java.util.Observer /*Hummingbird*/ Observer.closeObserver() { 
		return closeObsrv;
	}
}
