package observer;

import java.util.WeakHashMap;
import java.util.List;
import java.util.ArrayList;
import java.util.ListIterator;

public aspect ObservingClose extends ObservingRelationships {
//	private interface Subject {}
//	private interface Observer {}

	public abstract boolean Subject.isOpen();
	public abstract void Observer.bedtimeSleep();
	private boolean Subject.alreadyClosed = false;

//	private WeakHashMap subject2ObserversMap = new WeakHashMap();
//	private List getObservers(Subject subject) {
//		List observers = (List)subject2ObserversMap.get(subject);
//		if(observers == null) {
//			observers = new ArrayList();
//			subject2ObserversMap.put(subject, observers);
//		}
//		return observers;
//	}
//	public void addObserver(Subject subject, Observer observer) {
//		List observers = getObservers(subject);
//		if(!observers.contains(observer))
//			observers.add(observer);
//		subject2ObserversMap.put(subject, observers);
//	}
//	public void removeObserver(Subject subject, Observer observer) {
//		getObservers(subject).remove(observer);
//	}
//	public void clearObservers(Subject subject) {
//		getObservers(subject).clear();
//	}
	protected void notifyObservers(Subject subject) {
		if(!subject.isOpen() && !subject.alreadyClosed) {
			subject.alreadyClosed = true;
			List observers = getObservers(subject);
			for(ListIterator it = observers.listIterator(); it.hasNext();) {
				((Observer)it.next()).bedtimeSleep();
			}
		}
	}
	pointcut flowerOpen(Subject subject):
		execution(void open()) && this(subject);
	after(Subject subject) returning : flowerOpen(subject) {
		subject.alreadyClosed = false;
	}
	pointcut flowerClose(Subject subject):
		execution(void close()) && this(subject);
	after(Subject subject): flowerClose(subject) {
		notifyObservers(subject);
	}

	declare parents: Flower implements Subject;
	declare parents: (Bee || Hummingbird) implements Observer;
}