package observer;

import java.util.WeakHashMap;
import java.util.List;
import java.util.ArrayList;
import java.util.ListIterator;

public aspect ObservingClose extends ObservingRelationships {
	public abstract boolean Subject.isOpen();
	public abstract void Observer.bedtimeSleep();
	private boolean Subject.alreadyClosed = false;

	protected void notifyObservers(Subject subject) {
		if(!subject.isOpen() && !subject.alreadyClosed) {
			subject.alreadyClosed = true;
			List observers = getObservers(subject);
			for(ListIterator it = observers.listIterator(); it.hasNext();) {
				((Observer)it.next()).bedtimeSleep();
			}
		}
	}
	private pointcut flowerOpen(Subject subject):
		execution(void open()) && this(subject);
	after(Subject subject) returning : flowerOpen(subject) {
		subject.alreadyClosed = false;
	}
	protected pointcut flowerClose(Subject subject):
		execution(void close()) && this(subject);
	after(Subject subject): flowerClose(subject) {
		notifyObservers(subject);
	}

	declare parents: Flower implements Subject;
	declare parents: (Bee || Hummingbird) implements Observer;
}