package observer;

import java.util.Observable;

public aspect ObservingClose extends ObserverProtocol {
	declare parents: Flower implements Subject;
	declare parents: (Bee || Hummingbird) implements Observer;

	public abstract boolean Subject.isOpen();
	public abstract void Observer.bedtimeSleep();

	protected void updateObserver(Subject s, Observer o) { }

//	private interface BedtimeSleeper {
//		public void bedtimeSleep();
//	}
	//declare parents: (Bee || Hummingbird) implements BedtimeSleeper;

	static class CloseNotifier extends Observable {
		private Subject _enclosing;
		private boolean alreadyClosed = false;
		public CloseNotifier(Subject flower) {
			_enclosing = flower;
		}
		public void notifyObservers() {
			if(!_enclosing.isOpen() && !this.alreadyClosed) {
				this.setChanged();
				super.notifyObservers();
				this.alreadyClosed = true;
			}
		}
		public void open() {
			this.alreadyClosed = false;
		}
	}
	static class CloseObserver implements java.util.Observer {
		private Observer _enclosing;
		public CloseObserver(Observer enclosing) {
			_enclosing = enclosing;
		}
		public void update(Observable ob, Object a) {
			_enclosing.bedtimeSleep();
		}
	}
	private CloseNotifier Subject.cNotify = new CloseNotifier(this);
	private CloseObserver Observer.closeObsrv = new CloseObserver(this);
	//private CloseObserver Observer.closeObsrv = new CloseObserver(this);

	public Observable Subject.closing() {
		return cNotify;
	}
	pointcut flowerOpen(Subject flower):
		execution(void open()) && this(flower);
	after(Subject flower) returning : flowerOpen(flower) {
		flower.cNotify.open();
	}
	protected pointcut subjectChange(Subject subject):
		execution(void Subject+.close()) && this(subject);
	after(Subject subject): subjectChange(subject) {
		((Flower)subject).cNotify.notifyObservers();
	}
	public java.util.Observer Observer.closeObserver() { 
		return closeObsrv;
	}
//	public java.util.Observer Observer.closeObserver() { 
//		return closeObsrv;
//	}
}
