package observer;

import java.util.Iterator;

public aspect ObservingOpen extends ObserverProtocol {
	declare parents: Flower implements Subject;
	declare parents: (Bee || Hummingbird) implements Observer;
	public abstract void Observer.breakfastTime();
	private boolean Subject.alreadyOpen = false;

	protected pointcut subjectChange(Subject subject):
		execution(void Subject+.open()) && this(subject);
	after(Subject s): subjectChange(s) {
		Flower f = (Flower)s;
		if(f.isOpen() && !f.alreadyOpen) {
			Iterator iter = getObservers(s).iterator();
			while ( iter.hasNext() ) {
				updateObserver(s, ((Observer)iter.next()));
			}
		}
	}
	pointcut flowerClose(Subject flower):
		execution(void close()) && this(flower);
	after(Subject subject): flowerClose(subject) {
		if (subject instanceof Flower) {
			((Flower)subject).alreadyOpen = false;
		}
	}
	protected void updateObserver(Subject s, Observer o) {
		o.breakfastTime();
		((Flower)s).alreadyOpen = true;
	}
}
