package util;

/**
 * @author Miguel Pessoa Monteiro
 */
public abstract aspect OutputCapture {
	protected static String resultStr = "";

	public abstract pointcut printScope();

	public pointcut messagesFromSystemOutPrintln(Object message):
		Pointcuts.call2SystemOutPrintln()
		&& printScope()
		&& args(message);
		
	/**
	 * Capture all messages from System.out.println(Object)
	 */
	void around(Object message): messagesFromSystemOutPrintln(message) {
		resultStr += message.toString() + "\n";
		proceed(message);
	}
	public static String getResult() {
		return resultStr;
	}
	public static void clearResult() {
		resultStr = "";
	}
	public static void printResult() {
		System.out.println("\nCAPTURED OUTPUT:[" + resultStr + "]");
	}
}
